﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace HL_1
{
    public partial class DispForm2 : HL_1.DispFormParent
    {
        MainForm Mf;
        public DispForm2(MainForm f)
        {
            Mf = f; 
            InitializeComponent();
        }

        override public void PlotSimDisp(double SimTime, cCell myCell)
        {
            bool BlnFirstPlot_LDisp = Pd.BlnFirstPlot_LDisp;
            //************************************************************************
            ucPicBox1.PlotSimData(SimTime, myCell.SR.Casr, ref ucPicBox1.myPoint[0], BlnFirstPlot_LDisp);

            //************************************************************************
            ucPicBox2.PlotSimData(SimTime, myCell.Mitochondria.Camit, ref ucPicBox2.myPoint[0], BlnFirstPlot_LDisp);

            //************************************************************************
            ucPicBox3.PlotSimData(SimTime, myCell.SR.SERCA.Itc, ref ucPicBox3.myPoint[0], BlnFirstPlot_LDisp);
            ucPicBox3.PlotSimData(SimTime, myCell.SR.RyR.Itc, ref ucPicBox3.myPoint[1], BlnFirstPlot_LDisp);
            ucPicBox3.PlotSimData(SimTime, myCell.SR.Leak.Itc, ref ucPicBox3.myPoint[2], BlnFirstPlot_LDisp);

            //************************************************************************
            ucPicBox4.PlotSimData(SimTime, myCell.Mitochondria.CaUni.Itc, ref ucPicBox4.myPoint[0], BlnFirstPlot_LDisp);
            ucPicBox4.PlotSimData(SimTime, myCell.Mitochondria.NCXmit.Itc, ref ucPicBox4.myPoint[1], BlnFirstPlot_LDisp);
        }

        override public void DispXmax(double TimeMax)
        {
            base.DispXmax(TimeMax);
        }
        override public void GetNewSettings()
        {
            base.GetNewSettings();
        }
        override public void EraseGraphs()
        {
            base.EraseGraphs();
        }

        override public void DispLabels(cCell myCell)
        {
            //************************************************************************
            ucPicBox1.lbl_Var1.Text = myCell.SR.Casr.ToString("0.0E0");

            //************************************************************************
            ucPicBox2.lbl_Var1.Text = myCell.Mitochondria.Camit.ToString("0.0E0");

            //************************************************************************
            ucPicBox3.lbl_Var1.Text = String.Format("{0,6:#.#0}", myCell.TVc[Pd.InxSERCA_Itc]);
            ucPicBox3.lbl_Var2.Text = String.Format("{0,6:#.#0}", myCell.TVc[Pd.InxRyR_Itc]);
            ucPicBox3.lbl_Var3.Text = String.Format("{0,6:#.#0}", myCell.TVc[Pd.InxLeak_Itc]);

            //************************************************************************
            ucPicBox4.lbl_Var1.Text = String.Format("{0,6:#.#0}", myCell.TVc[Pd.InxCaUni_Itc]);
            ucPicBox4.lbl_Var2.Text = String.Format("{0,6:#.#0}", myCell.TVc[Pd.InxNCXmit_Itc]);
        }

        

        override public void SendImageBmpToPbox()
        {
            base.SendImageBmpToPbox();
        }

        private void DispForm2_Load(object sender, EventArgs e)
        {
            //************************************************************************
            ucPicBox1.lbl_Var1Str.Text = "Casr";
            ucPicBox1.txb_Ymax.Text = "0.5";
            ucPicBox1.txb_Ymin.Text = "0.0";

            //************************************************************************
            ucPicBox2.lbl_Var1Str.Text = "Camit";
            ucPicBox2.txb_Ymax.Text = "0.006";
            ucPicBox2.txb_Ymin.Text = "0.0";

            //************************************************************************
            ucPicBox3.lbl_Var1Str.Text = "SERCA";
            ucPicBox3.lbl_Var2Str.Text = "RyR";
            ucPicBox3.lbl_Var3Str.Text = "Leak";
            ucPicBox3.txb_Ymax.Text = "300";
            ucPicBox3.txb_Ymin.Text = "-60";

            //************************************************************************
            ucPicBox4.lbl_Var1Str.Text = "CaUni";
            ucPicBox4.lbl_Var2Str.Text = "NCXmit";
            ucPicBox4.txb_Ymax.Text = "0.0";
            ucPicBox4.txb_Ymin.Text = "-0.5";

            Top = 0;
            Left = Mf.DispForm1.Width;
            Height = Mf.DispForm1.Height;
            Width = Mf.DispForm1.Width;
        }
    }
}
