﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Drawing;
using System.Threading.Tasks;

namespace HL_1
{
    public class Pd
    {
        public struct TPBoxProperty
        {
            public double XMin;
            public double XMax;
            public double X0;
            public double XCal;
            public double YMin;
            public double YMax;
            public double Y0;
            public double YCal;
        };
        public struct TIdx
        {
            public int TType;
            public int n;
            public string Name;
        };

        public struct TIons
        {
            public double Na;
            public double K;
            public double Ca;
            public double Cajs;
            public double Casl;
            public double Cl;
            public double Mg;
        };

        public struct TModelSetting
        {
            public int intClampMode;			//Clamp mode: CurrentClamp = 0;  VoltageClamp = 1;
            public double SimTimeMax;
            public double LDispTimeMax;
            public double SDispTimeMax;
            public double StimCycle;
        };

        public struct TmyPenS
        {
            public int i;
            public Point P0;
            public Point P1;
            public System.Drawing.Color MyColor;
        };

        static public int mTVIdxMax = 100;
        static public int mTVMax = 500000;
        static public int mTVMax_beat = 10000;
        static public int mTVIdxLast;
        static public int mTVIdxLast_beat;


        public class mTV_VStr
        {
            public int Idx;
            public string Str;
            public double[] Val = new double[mTVMax]; // max 100000 points 
        }

        public class mTV_VStr2
        {
            public int Idx;
            public string Str;
            public double[] Val = new double[mTVMax_beat]; // max 100000 points 
        }

        public class TdVdTPeak
        {
            public double SDTime;
            public double ElpTime;
            public double dVdTPeak;
            public bool blDetect;
        }

        //static public double R = 8.3143;				//'Gas constant
        static public double R = 8.314472;				//'Gas constant
        static public double T = 310.0;				//'absolute temperature
        //static public double F = 96.4867;				//'Faraday const. Coulomb/mM
        static public double F = 96.48653415;				//'Faraday const. Coulomb/mM
        static public double RTF = R * T / F;			//  'valent ions
        static public double RTF2 = R * T / F / 2.0;		//'for divalent ions

        static public int IntVar = 1;
        static public int IntPar = 2;

        static public TModelSetting MSet;
        static public bool BlnFirstLoad;
        static public bool BlnFirstPlot_SDisp;
        static public bool BlnFirstPlot_LDisp;

        static public bool BlnFirstPLFormLoad = true;

        //index of parameters
        //that enter Runge-Kutta
        static public int IdxVm = 0;   //    membrane potential
        static public int IdxNai = 1;   //    Free Na concentration in cytoplasm
        static public int IdxKi = 2;   //    Free K concentration in cytoplasm
        static public int IdxCai = 3;   //    Free Ca concentration in cytoplasm
        static public int IdxCli = 4;   //   Free Cl concentration in cytoplasm

        static public int IdxCajs = 5;   //    Free Ca concentration in junctional space
        static public int IdxCasl = 6;   //    Free Ca concentration in subsarcolemmal space

        static public int IdxCasr = 7; // Free Ca concentration in SR

        static public int IdxCamit_tot = 8; // total Ca concentration in mitochondria

        static public int IdxINa_m_js = 9; // m gate of INajs
        static public int IdxINa_h_js = 10; // h gate of INajs
        static public int IdxINa_j_js = 11; // j gate of INajs
        static public int IdxINa_m_sl = 12; // m gate of INasl
        static public int IdxINa_h_sl = 13; // h gate of INasl
        static public int IdxINa_j_sl = 14; // j gate of INasl

        static public int IdxIKr_xkr_js = 15; // gate of IKrjs
        static public int IdxIKr_xkr_sl = 16; // gate of IKrsl

        static public int IdxIKs_xks_js = 17; // gate of IKsjs
        static public int IdxIKs_xks_sl = 18; // gate of IKssl

        static public int IdxICaL_d_js = 19; // d gate of ICaLjs
        static public int IdxICaL_f_js = 20; // f gate of ICaLjs
        static public int IdxICaL_fCaB_js = 21; //fCaB gate of ICaLjs
        static public int IdxICaL_d_sl = 22; // d gate of ICaLsl
        static public int IdxICaL_f_sl = 23; // f gate of ICaLsl
        static public int IdxICaL_fCaB_sl = 24; // fCaB gate of ICaLsl

        static public int IdxIha_y_js = 25; //  y gate of Ihajs
        static public int IdxIha_y_sl = 26; //  y gate of Ihasl

        static public int IdxICaT_d_js = 27; // d gate of ICaTjs
        static public int IdxICaT_f_js = 28; // f gate of ICaTjs
        static public int IdxICaT_d_sl = 29; // d gate of ICaTsl
        static public int IdxICaT_f_sl = 30; // f gate of ICaTsl

        static public int IdxIto_xto_js = 31; // x gate of Itojs
        static public int IdxIto_yto_js = 32; // y gate of Itojs
        static public int IdxIto_xto_sl = 33; // x gate of Itosl
        static public int IdxIto_yto_sl = 34; // y gate of Itosl

        static public int IdxIKur_xkur_js = 35; // x gate of IKurjs
        static public int IdxIKur_ykur_js = 36; // y gate of IKurjs
        static public int IdxIKur_xkur_sl = 37; // x gate of IKursl
        static public int IdxIKur_ykur_sl = 38; // y gate of IKursl

        static public int IdxbTnClow = 39; //  bound troponinC low affinity site in cytoplasm
        static public int IdxbTnChCa = 40; //  Ca bound troponinC high affinity site in cytoplasm
        static public int IdxbTnChMg = 41; // Mg bound troponinC high affinity site in cytoplasm
        static public int IdxbCaM = 42; // bound CaM in cytoplasm
        static public int IdxbMyocinCa = 43; // Ca bound Myocin in cytoplasm
        static public int IdxbMyocinMg = 44; // Mg bound Myocin in cytoplasm
        static public int IdxbSRB = 45; // bound SRB in cytoplasm

        static public int IdxbCabuffjs_low = 46; // bound Ca buffer low affinity site in junctional space
        static public int IdxbCabuffjs_high = 47; // bound Ca buffer high affinity site in junctional space
        static public int IdxbCabuffsl_low = 48; // bound Ca buffer low affinity site in subsarcolemmal space
        static public int IdxbCabuffsl_high = 49; // bound Ca buffer high affinity site in subsarcolemmal space

        static public int IdxRyR_R = 50; //  R state of RyR channel
        static public int IdxRyR_O = 51; //  O state of RyR channel
        static public int IdxRyR_I = 52; //  I state of RyR channel

        static public int IdxbCSQN = 53; // bound calsequestrin

        static public int NOPRungeKutta = 53;

        //index of parameters that Not enter Runge-Kutta
        static public int FirstNonRK = 200;

        static public int InxCamit = 200;

        static public int InxINajs_Itc = 201;
        static public int InxINasl_Itc = 202;
        static public int InxINaKjs_Itc = 203;
        static public int InxINaKsl_Itc = 204;
        static public int InxIKrjs_Itc = 205;
        static public int InxIKrsl_Itc = 206;
        static public int InxIKsjs_Itc = 207;
        static public int InxIKssl_Itc = 208;
        static public int InxIKpjs_Itc = 209;
        static public int InxIKpsl_Itc = 210;
        static public int InxIClCajs_Itc = 211;
        static public int InxIClCasl_Itc = 212;
        static public int InxICaLjs_Itc = 213;
        static public int InxICaL_Cajs = 214;
        static public int InxICaL_Najs = 215;
        static public int InxICaL_Kjs = 216;
        static public int InxICaLsl_Itc = 217;
        static public int InxICaL_Casl = 218;
        static public int InxICaL_Nasl = 219;
        static public int InxICaL_Ksl = 220;
        static public int InxINaCajs_Itc = 221;
        static public int InxINaCasl_Itc = 222;
        static public int InxIpCajs_Itc = 223;
        static public int InxIpCasl_Itc = 224;
        static public int InxICabjs_Itc = 225;
        static public int InxICabsl_Itc = 226;
        static public int InxIhajs_Itc = 227;
        static public int InxIha_Najs = 228;
        static public int InxIha_Kjs = 229;
        static public int InxIhasl_Itc = 230;
        static public int InxIha_Nasl = 231;
        static public int InxIha_Ksl = 232;
        static public int InxICaTjs_Itc = 233;
        static public int InxICaTsl_Itc = 234;
        static public int InxItojs_Itc = 235;
        static public int InxItosl_Itc = 236;
        static public int InxIKurjs_Itc = 237;
        static public int InxIKursl_Itc = 238;
        static public int InxIK1js_Itc = 239;
        static public int InxIK1_gate_js = 240;
        static public int InxIK1sl_Itc = 241;
        static public int InxIK1_gate_sl = 242;
        static public int InxIClbjs_Itc = 243;
        static public int InxIClbsl_Itc = 244;

        static public int InxJCabuff_cyt_tot = 245;
        static public int InxJCabuff_js_tot = 246;
        static public int InxJCabuff_sl_tot = 247;
        static public int InxJCadiff_cytsl = 248;
        static public int InxJCadiff_jssl = 249;

        static public int InxSERCA_Itc = 250;
        static public int InxJSERCA = 251;
        static public int InxRyR_Itc = 252;
        static public int InxJRyR = 253;
        static public int InxLeak_Itc = 254;
        static public int InxJLeak = 255;
        static public int InxJCSQN = 256;

        static public int InxCaUni_Itc = 257;
        static public int InxJCaUni = 258;
        static public int InxNCXmit_Itc = 259;
        static public int InxJNCXmit = 260;

        static public int InxRpNa = 261;
        static public int InxRpK = 262;
        static public int InxRpCajs = 263;
        static public int InxRpCasl = 264;
        static public int InxRpCl = 265;

        static public int InxHR = 266;
        static public int InxCL = 267;
        static public int InxdvdTmax = 268;

        static public int InxVm_Min = 269;
        static public int InxVm_Max = 270;
        static public int InxCai_Min = 271;
        static public int InxCai_Max = 272;
        static public int InxCajs_Min = 273;
        static public int InxCajs_Max = 274;
        static public int InxCasl_Min = 275;
        static public int InxCasl_Max = 276;
        static public int InxCasr_Min = 277;
        static public int InxCasr_Max = 278;
        static public int InxCamit_Min = 279;
        static public int InxCamit_Max = 280;

        static public int IdxLast = 1000;

        static public void NameTV(string[] TVcStr)
        {
            //index of parameters
            //that enter Runge-Kutta
            TVcStr[IdxVm] = "Vm";   // membrane potential, 0
            TVcStr[IdxNai] = "Nai";   // Free Na concentration in cytoplasm, 1
            TVcStr[IdxKi] = "Ki";   // Free K concentration in cytoplasm, 2
            TVcStr[IdxCai] = "Cai";   // Free Ca concentration in cytoplasm, 3
            TVcStr[IdxCli] = "Cli";   // Free Cl concentration in cytoplasm, 4
            TVcStr[IdxCajs] = "Cajs";   // Free Ca concentration in junctional space, 5
            TVcStr[IdxCasl] = "Casl";   // Free Ca concentration in subsarcolemmal space, 6
            TVcStr[IdxCasr] = "Casr";   // Free Ca concentration in SR, 7
            TVcStr[IdxCamit_tot] = "Camit_tot";   // total Ca concentration in mitochondria, 8
            TVcStr[IdxINa_m_js] = "INa_m_js";   // m gate of INajs, 9
            TVcStr[IdxINa_h_js] = "INa_h_js";   // h gate of INajs, 10
            TVcStr[IdxINa_j_js] = "INa_j_js";   // j gate of INajs, 11
            TVcStr[IdxINa_m_sl] = "INa_m_sl";   // m gate of INasl, 12
            TVcStr[IdxINa_h_sl] = "INa_h_sl";   // h gate of INasl, 13
            TVcStr[IdxINa_j_sl] = "INa_j_sl";   // j gate of INasl, 14
            TVcStr[IdxIKr_xkr_js] = "IKr_xkr_js";   // gate of IKrjs, 15
            TVcStr[IdxIKr_xkr_sl] = "IKr_xkr_sl";   //gate of IKrsl, 16
            TVcStr[IdxIKs_xks_js] = "IKs_xks_js";   //  gate of IKsjs, 17
            TVcStr[IdxIKs_xks_sl] = "IKs_xks_sl";   //  gate of IKssl, 18
            TVcStr[IdxICaL_d_js] = "ICaL_d_js";   //  d gate of ICaLjs, 19
            TVcStr[IdxICaL_f_js] = "ICaL_f_js";   //  f gate of ICaLjs, 20
            TVcStr[IdxICaL_fCaB_js] = "ICaL_fCaB_js";   // fCaB gate of ICaLjs, 21
            TVcStr[IdxICaL_d_sl] = "ICaL_d_sl";   // d gate of ICaLsl, 22
            TVcStr[IdxICaL_f_sl] = "ICaL_f_sl";   // f gate of ICaLsl, 23
            TVcStr[IdxICaL_fCaB_sl] = "ICaL_fCaB_sl";   // fCaB gate of ICaLsl, 24
            TVcStr[IdxIha_y_js] = "Iha_y_js";   // y gate of Ihajs, 25
            TVcStr[IdxIha_y_sl] = "Iha_y_sl";   // y gate of Ihasl, 26
            TVcStr[IdxICaT_d_js] = "ICaT_d_js"; // d gate of ICaTjs, 27
            TVcStr[IdxICaT_f_js] = "ICaT_f_js"; // f gate of ICaTjs, 28
            TVcStr[IdxICaT_d_sl] = "ICaT_d_sl"; // d gate of ICaTsl, 29
            TVcStr[IdxICaT_f_sl] = "ICaT_f_sl"; // f gate of ICaTsl, 30
            TVcStr[IdxIto_xto_js] = "Ito_xto_js";   // x gate of Itojs, 31
            TVcStr[IdxIto_yto_js] = "Ito_yto_js";   // y gate of Itojs, 32
            TVcStr[IdxIto_xto_sl] = "Ito_xto_sl";   // x gate of Itojs, 33
            TVcStr[IdxIto_yto_sl] = "Ito_yto_sl";   // y gate of Itojs, 34
            TVcStr[IdxIKur_xkur_js] = "IKur_xkur_js";   // x gate of IKurjs, 35
            TVcStr[IdxIKur_ykur_js] = "IKur_ykur_js";   // y gate of IKurjs, 36
            TVcStr[IdxIKur_xkur_sl] = "IKur_xkur_sl";   // x gate of IKursl, 37
            TVcStr[IdxIKur_ykur_sl] = "IKur_ykur_sl";   // y gate of IKursl, 38
            TVcStr[IdxbTnClow] = "bTnClow";   // bound troponinC low affinity site in cytoplasm, 39
            TVcStr[IdxbTnChCa] = "bTnChCa";   // Ca bound troponinC high affinity site in cytoplasm, 40
            TVcStr[IdxbTnChMg] = "bTnChMg";   // Mg bound troponinC high affinity site in cytoplasm, 41
            TVcStr[IdxbCaM] = "bCaM";   // bound CaM in cytoplasm, 42
            TVcStr[IdxbMyocinCa] = "bMyocinCa";   // Ca bound Myocin in cytoplasm, 43
            TVcStr[IdxbMyocinMg] = "bMyocinMg";   // Mg bound Myocin in cytoplasm, 44
            TVcStr[IdxbSRB] = "bSRB";   //bound SRB in cytoplasm, 45
            TVcStr[IdxbCabuffjs_low] = "bCabuffjs_low";   // bound Ca buffer low affinity site in junctional space, 46
            TVcStr[IdxbCabuffjs_high] = "bCabuffjs_high";   // bound Ca buffer high affinity site in junctional space, 47
            TVcStr[IdxbCabuffsl_low] = "bCabuffsl_low";   // bound Ca buffer low affinity site in subsarcolemmal space, 48
            TVcStr[IdxbCabuffsl_high] = "bCabuffsl_high";   // bound Ca buffer high affinity site in subsarcolemmal space, 49
            TVcStr[IdxRyR_R] = "RyR_R";   // R state of RyR channel, 50
            TVcStr[IdxRyR_O] = "RyR_O";   // O state of RyR channel, 51
            TVcStr[IdxRyR_I] = "RyR_I";   // I state of RyR channel, 52
            TVcStr[IdxbCSQN] = "bCSQN";   // bound calsequestrin, 53

            //index of parameters that Not enter Runge-Kutta
            TVcStr[InxCamit] = "Camit"; //200;
            TVcStr[InxINajs_Itc] = "INajs_Itc"; //201;
            TVcStr[InxINasl_Itc] = "INasl_Itc"; //202;
            TVcStr[InxINaKjs_Itc] = "INaKjs_Itc"; //203;
            TVcStr[InxINaKsl_Itc] = "INaKsl_Itc"; //204;
            TVcStr[InxIKrjs_Itc] = "IKrjs_Itc"; //205;
            TVcStr[InxIKrsl_Itc] = "IKrsl_Itc"; //206;
            TVcStr[InxIKsjs_Itc] = "IKsjs_Itc"; //207;
            TVcStr[InxIKssl_Itc] = "IKssl_Itc"; //208;
            TVcStr[InxIKpjs_Itc] = "IKpjs_Itc"; //209;
            TVcStr[InxIKpsl_Itc] = "IKpsl_Itc"; //210;
            TVcStr[InxIClCajs_Itc] = "IClCajs_Itc"; //211;
            TVcStr[InxIClCasl_Itc] = "IClCasl_Itc"; //212;
            TVcStr[InxICaLjs_Itc] = "ICaLjs_Itc"; //213;
            TVcStr[InxICaL_Cajs] = "ICaL_Cajs"; //214;
            TVcStr[InxICaL_Najs] = "ICaL_Najs"; //215;
            TVcStr[InxICaL_Kjs] = "ICaL_Kjs"; //216;
            TVcStr[InxICaLsl_Itc] = "ICaLsl_Itc"; //217;
            TVcStr[InxICaL_Casl] = "ICaL_Casl"; //218;
            TVcStr[InxICaL_Nasl] = "ICaL_Nasl"; //219;
            TVcStr[InxICaL_Ksl] = "ICaL_Ksl"; //220;
            TVcStr[InxINaCajs_Itc] = "INaCajs_Itc"; //221;
            TVcStr[InxINaCasl_Itc] = "INaCasl_Itc"; //222;
            TVcStr[InxIpCajs_Itc] = "IpCajs_Itc"; //223;
            TVcStr[InxIpCasl_Itc] = "IpCasl_Itc"; //224;
            TVcStr[InxICabjs_Itc] = "ICabjs_Itc"; //225;
            TVcStr[InxICabsl_Itc] = "ICabsl_Itc"; //226;
            TVcStr[InxIhajs_Itc] = "Ihajs_Itc"; //227;
            TVcStr[InxIha_Najs] = "Iha_Najs"; //228;
            TVcStr[InxIha_Kjs] = "Iha_Kjs"; //229;
            TVcStr[InxIhasl_Itc] = "Ihasl_Itc"; //230;
            TVcStr[InxIha_Nasl] = "Iha_Nasl"; //231;
            TVcStr[InxIha_Ksl] = "Iha_Ksl";  //232;
            TVcStr[InxICaTjs_Itc] = "ICaTjs_Itc"; //233;
            TVcStr[InxICaTsl_Itc] = "ICaTsl_Itc"; //234;
            TVcStr[InxItojs_Itc] = "Itojs_Itc"; //235;
            TVcStr[InxItosl_Itc] = "Itosl_Itc"; //236;
            TVcStr[InxIKurjs_Itc] = "IKurjs_Itc"; //237;
            TVcStr[InxIKursl_Itc] = "IKursl_Itc"; //238;
            TVcStr[InxIK1js_Itc] = "IK1js_Itc"; //239;
            TVcStr[InxIK1_gate_js] = "IK1_gate_js"; //240;
            TVcStr[InxIK1sl_Itc] = "IK1sl_Itc"; //241;
            TVcStr[InxIK1_gate_sl] = "IK1_gate_sl"; //242;
            TVcStr[InxIClbjs_Itc] = "IClbjs_Itc"; //243;
            TVcStr[InxIClbsl_Itc] = "IClbsl_Itc"; //244;
            TVcStr[InxJCabuff_cyt_tot] = "JCabuff_cyt_tot"; //245;
            TVcStr[InxJCabuff_js_tot] = "JCabuff_js_tot"; //246;
            TVcStr[InxJCabuff_sl_tot] = "JCabuff_sl_tot"; //247;
            TVcStr[InxJCadiff_cytsl] = "JCadiff_cytsl"; //248;
            TVcStr[InxJCadiff_jssl] = "JCadiff_jssl"; //249;
            TVcStr[InxSERCA_Itc] = "SERCA_Itc"; //250;
            TVcStr[InxJSERCA] = "JSERCA"; //251;
            TVcStr[InxRyR_Itc] = "RyR_Itc"; //252;
            TVcStr[InxJRyR] = "JRyR"; //253;
            TVcStr[InxLeak_Itc] = "Leak_Itc"; //254;
            TVcStr[InxJLeak] = "JLeak"; //255;
            TVcStr[InxJCSQN] = "JCSQN"; //256;
            TVcStr[InxCaUni_Itc] = "CaUni_Itc"; //257;
            TVcStr[InxJCaUni] = "JCaUni"; //258;
            TVcStr[InxNCXmit_Itc] = "NCXmit_Itc"; //259;
            TVcStr[InxJNCXmit] = "JNCXmit"; //260;
            TVcStr[InxRpNa] = "RpNa"; //261;
            TVcStr[InxRpK] = "RpK"; //262;
            TVcStr[InxRpCajs] = "RpCajs"; //263;
            TVcStr[InxRpCasl] = "RpCasl"; //264;
            TVcStr[InxRpCl] = "RpCl"; //265;
            TVcStr[InxHR] = "HR"; //266;
            TVcStr[InxCL] = "CL"; //267;
            TVcStr[InxdvdTmax] = "dvdTmax"; //268;
            TVcStr[InxVm_Min] = "Vm_Min"; //269;
            TVcStr[InxVm_Max] = "Vm_Max"; //270;
            TVcStr[InxCai_Min] = "Cai_Min"; //271;
            TVcStr[InxCai_Max] = "Cai_Max"; //272;
            TVcStr[InxCajs_Min] = "Cajs_Min"; //273;
            TVcStr[InxCajs_Max] = "Cajs_Max"; //274;
            TVcStr[InxCasl_Min] = "Casl_Min"; //275;
            TVcStr[InxCasl_Max] = "Casl_Max"; //276;
            TVcStr[InxCasr_Min] = "Casr_Min"; //277;
            TVcStr[InxCasr_Max] = "Casr_Max"; //278;
            TVcStr[InxCamit_Min] = "Camit_Min"; //279;
            TVcStr[InxCamit_Max] = "Camit_Max"; //280;
        }
    }
}
