﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace HL_1
{
    public class cCabuffcyt : cElement
    {
        private Pd.TIdx IxbTnClow;
        private Pd.TIdx IxkonTnClow;
        private Pd.TIdx IxkoffTnClow;
        private Pd.TIdx IxTnClowtot;

        private Pd.TIdx IxbTnChCa;
        private Pd.TIdx IxkonTnChCa;
        private Pd.TIdx IxkoffTnChCa;
        private Pd.TIdx IxbTnChMg;
        private Pd.TIdx IxkonTnChMg;
        private Pd.TIdx IxkoffTnChMg;
        private Pd.TIdx IxTnChightot;

        private Pd.TIdx IxbCaM;
        private Pd.TIdx IxkonCaM;
        private Pd.TIdx IxkoffCaM;
        private Pd.TIdx IxCaMtot;

        private Pd.TIdx IxbMyocinCa;
        private Pd.TIdx IxkonMyocinCa;
        private Pd.TIdx IxkoffMyocinCa;
        private Pd.TIdx IxbMyocinMg;
        private Pd.TIdx IxkonMyocinMg;
        private Pd.TIdx IxkoffMyocinMg;
        private Pd.TIdx IxMyocintot;

        private Pd.TIdx IxbSRB;
        private Pd.TIdx IxkonSRB;
        private Pd.TIdx IxkoffSRB;
        private Pd.TIdx IxSRBtot;

        private Pd.TIdx IxJCabuff_cyt_tot;

        public double bTnClow;  // bound troponinC low affinity site in cytoplasm
        public double konTnClow = 32.7; // /mM*msec
        public double koffTnClow = 0.0196; // /msec
        public double TnClowtot = 0.07; // mM

        public double bTnChCa;  // Ca bound troponinC high affinity site in cytoplasm
        public double konTnChCa = 2.37; // /mM*msec
        public double koffTnChCa = 3.2E-5; // /msec
        public double bTnChMg;  // Mg bound troponinC high affinity site in cytoplasm
        public double konTnChMg = 0.003; // /mM*msec
        public double koffTnChMg = 0.00333; // /msec
        public double TnChightot = 0.14; // mM

        public double bCaM;  // bound CaM in cytoplasm
        public double konCaM = 34.0; // /mM*msec
        public double koffCaM = 0.238; // /msec
        public double CaMtot = 0.024; // mM

        public double bMyocinCa;  // Ca bound Myocin in cytoplasm
        public double konMyocinCa = 13.8; // /mM*msec
        public double koffMyocinCa = 4.6E-4; // /msec
        public double bMyocinMg;  // Mg bound Myocin in cytoplasm
        public double konMyocinMg = 0.0157; // /mM*msec
        public double koffMyocinMg = 5.7E-5; // /msec
        public double Myocintot = 0.14; // mM

        public double bSRB;  // bound SRB in cytoplasm
        public double konSRB = 100.0; // /mM*msec
        public double koffSRB = 0.06; // /msec
        public double SRBtot = 0.0171; // mM

        public double JCabuff_cyt_tot;

        public cCabuffcyt()  //コンストラクター 
        {
        }

        override public void Initialize(ref double[] myTVc, ref cCell myCell, ref ListForm Lf)
        {
            int i = 0;

            SetIx(ref IxbTnClow, ref i, Pd.IntVar, "bTnClow");
            SetIx(ref IxkonTnClow, ref i, Pd.IntPar, "konTnClow");
            SetIx(ref IxkoffTnClow, ref i, Pd.IntPar, "koffTnClow");
            SetIx(ref IxTnClowtot, ref i, Pd.IntPar, "TnClowtot");

            SetIx(ref IxbTnChCa, ref i, Pd.IntVar, "bTnChCa");
            SetIx(ref IxkonTnChCa, ref i, Pd.IntPar, "konTnChCa");
            SetIx(ref IxkoffTnChCa, ref i, Pd.IntPar, "koffTnChCa");
            SetIx(ref IxbTnChMg, ref i, Pd.IntVar, "bTnChMg");
            SetIx(ref IxkonTnChMg, ref i, Pd.IntPar, "konTnChMg");
            SetIx(ref IxkoffTnChMg, ref i, Pd.IntPar, "koffTnChMg");
            SetIx(ref IxTnChightot, ref i, Pd.IntPar, "TnChightot");

            SetIx(ref IxbCaM, ref i, Pd.IntVar, "bCaM");
            SetIx(ref IxkonCaM, ref i, Pd.IntPar, "konCaM");
            SetIx(ref IxkoffCaM, ref i, Pd.IntPar, "koffCaM");
            SetIx(ref IxCaMtot, ref i, Pd.IntPar, "CaMtot");

            SetIx(ref IxbMyocinCa, ref i, Pd.IntVar, "bMyocinCa");
            SetIx(ref IxkonMyocinCa, ref i, Pd.IntPar, "konMyocinCa");
            SetIx(ref IxkoffMyocinCa, ref i, Pd.IntPar, "koffMyocinCa");
            SetIx(ref IxbMyocinMg, ref i, Pd.IntVar, "bMyocinMg");
            SetIx(ref IxkonMyocinMg, ref i, Pd.IntPar, "konMyocinMg");
            SetIx(ref IxkoffMyocinMg, ref i, Pd.IntPar, "koffMyocinMg");
            SetIx(ref IxMyocintot, ref i, Pd.IntPar, "Myocintot");

            SetIx(ref IxbSRB, ref i, Pd.IntVar, "bSRB");
            SetIx(ref IxkonSRB, ref i, Pd.IntPar, "konSRB");
            SetIx(ref IxkoffSRB, ref i, Pd.IntPar, "koffSRB");
            SetIx(ref IxSRBtot, ref i, Pd.IntPar, "SRBtot");

            SetIx(ref IxJCabuff_cyt_tot, ref i, Pd.IntVar, "JCabuff_cyt_tot");

            NumOfIx = i;

            Lf.DGViews_Initialize(Lf.tpCabuffcyt_ListView, NumOfIx);

            bTnClow = myTVc[Pd.IdxbTnClow];
            bTnChCa = myTVc[Pd.IdxbTnChCa];
            bTnChMg = myTVc[Pd.IdxbTnChMg];
            bCaM = myTVc[Pd.IdxbCaM];
            bMyocinCa = myTVc[Pd.IdxbMyocinCa];
            bMyocinMg = myTVc[Pd.IdxbMyocinMg];
            bSRB = myTVc[Pd.IdxbSRB];

            JCabuff_cyt_tot = myTVc[Pd.InxJCabuff_cyt_tot];
        }

        override public void dydt(double dt, ref double[] tvDYdt, ref double[] tvY, cCell myCell)
        {
            double ISO = myCell.ExtCell.ISO;
            double Cai = tvY[Pd.IdxCai];
            double Mgi =myCell.Cyt.Mgi;

            double koffTnClow_ = koffTnClow * (1 + 0.5 * ISO * 1000);

            bTnClow = tvY[Pd.IdxbTnClow];
            bTnChCa = tvY[Pd.IdxbTnChCa];
            bTnChMg = tvY[Pd.IdxbTnChMg];
            bCaM = tvY[Pd.IdxbCaM];
            bMyocinCa = tvY[Pd.IdxbMyocinCa];
            bMyocinMg = tvY[Pd.IdxbMyocinMg];
            bSRB = tvY[Pd.IdxbSRB];

            tvDYdt[Pd.IdxbTnClow] = konTnClow * Cai * (TnClowtot - bTnClow) - koffTnClow_ * bTnClow;
            tvDYdt[Pd.IdxbTnChCa] = konTnChCa * Cai * (TnChightot - bTnChCa - bTnChMg) - koffTnChCa * bTnChCa;
            tvDYdt[Pd.IdxbTnChMg] = konTnChMg * Mgi * (TnChightot - bTnChCa - bTnChMg) - koffTnChMg * bTnChMg;
            tvDYdt[Pd.IdxbCaM] = konCaM * Cai * (CaMtot - bCaM) - koffCaM * bCaM;
            tvDYdt[Pd.IdxbMyocinCa] = konMyocinCa * Cai * (Myocintot - bMyocinCa - bMyocinMg) - koffMyocinCa * bMyocinCa;
            tvDYdt[Pd.IdxbMyocinMg] = konMyocinMg * Mgi * (Myocintot - bMyocinCa - bMyocinMg) - koffMyocinMg * bMyocinMg;
            tvDYdt[Pd.IdxbSRB] = konSRB * Cai * (SRBtot - bSRB) - koffSRB * bSRB;

            JCabuff_cyt_tot = tvDYdt[Pd.IdxbTnClow] + tvDYdt[Pd.IdxbTnChCa] + tvDYdt[Pd.IdxbTnChMg] + tvDYdt[Pd.IdxbCaM] + tvDYdt[Pd.IdxbMyocinCa] + tvDYdt[Pd.IdxbMyocinMg] + tvDYdt[Pd.IdxbSRB];
        }

        override public void TransforToTV(ref double[] myTVc, cCell myCell)
        {
            myTVc[Pd.InxJCabuff_cyt_tot] = JCabuff_cyt_tot;
        }

        override public void DispValues(ref ListForm Lf)
        {
            ucListView ListView = Lf.tpCabuffcyt_ListView;
            ListView.LVDispValue("Cabuffcyt", IxbTnClow, ref bTnClow);
            ListView.LVDispValue("Cabuffcyt", IxkonTnClow, ref konTnClow);
            ListView.LVDispValue("Cabuffcyt", IxkoffTnClow, ref koffTnClow);
            ListView.LVDispValue("Cabuffcyt", IxTnClowtot, ref TnClowtot);

            ListView.LVDispValue("Cabuffcyt", IxbTnChCa, ref bTnChCa);
            ListView.LVDispValue("Cabuffcyt", IxkonTnChCa, ref konTnChCa);
            ListView.LVDispValue("Cabuffcyt", IxkoffTnChCa, ref koffTnChCa);
            ListView.LVDispValue("Cabuffcyt", IxbTnChMg, ref bTnChMg);
            ListView.LVDispValue("Cabuffcyt", IxkonTnChMg, ref konTnChMg);
            ListView.LVDispValue("Cabuffcyt", IxkoffTnChMg, ref koffTnChMg);
            ListView.LVDispValue("Cabuffcyt", IxTnChightot, ref TnChightot);

            ListView.LVDispValue("Cabuffcyt", IxbCaM, ref bCaM);
            ListView.LVDispValue("Cabuffcyt", IxkonCaM, ref konCaM);
            ListView.LVDispValue("Cabuffcyt", IxkoffCaM, ref koffCaM);
            ListView.LVDispValue("Cabuffcyt", IxCaMtot, ref CaMtot);

            ListView.LVDispValue("Cabuffcyt", IxbMyocinCa, ref bMyocinCa);
            ListView.LVDispValue("Cabuffcyt", IxkonMyocinCa, ref konMyocinCa);
            ListView.LVDispValue("Cabuffcyt", IxkoffMyocinCa, ref koffMyocinCa);
            ListView.LVDispValue("Cabuffcyt", IxbMyocinMg, ref bMyocinMg);
            ListView.LVDispValue("Cabuffcyt", IxkonMyocinMg, ref konMyocinMg);
            ListView.LVDispValue("Cabuffcyt", IxkoffMyocinMg, ref koffMyocinMg);
            ListView.LVDispValue("Cabuffcyt", IxMyocintot, ref Myocintot);

            ListView.LVDispValue("Cabuffcyt", IxbSRB, ref bSRB);
            ListView.LVDispValue("Cabuffcyt", IxkonSRB, ref konSRB);
            ListView.LVDispValue("Cabuffcyt", IxkoffSRB, ref koffSRB);
            ListView.LVDispValue("Cabuffcyt", IxSRBtot, ref SRBtot);

            ListView.LVDispValue("Cabuffcyt", IxJCabuff_cyt_tot, ref JCabuff_cyt_tot);
        }

        override public void ModiValues(ref ListForm Lf)
        {
            ucListView ListView = Lf.tpCabuffcyt_ListView;
            ListView.LVModiValue("Cabuffcyt", IxbTnClow, ref bTnClow);
            ListView.LVModiValue("Cabuffcyt", IxkonTnClow, ref konTnClow);
            ListView.LVModiValue("Cabuffcyt", IxkoffTnClow, ref koffTnClow);
            ListView.LVModiValue("Cabuffcyt", IxTnClowtot, ref TnClowtot);

            ListView.LVModiValue("Cabuffcyt", IxbTnChCa, ref bTnChCa);
            ListView.LVModiValue("Cabuffcyt", IxkonTnChCa, ref konTnChCa);
            ListView.LVModiValue("Cabuffcyt", IxkoffTnChCa, ref koffTnChCa);
            ListView.LVModiValue("Cabuffcyt", IxbTnChMg, ref bTnChMg);
            ListView.LVModiValue("Cabuffcyt", IxkonTnChMg, ref konTnChMg);
            ListView.LVModiValue("Cabuffcyt", IxkoffTnChMg, ref koffTnChMg);
            ListView.LVModiValue("Cabuffcyt", IxTnChightot, ref TnChightot);

            ListView.LVModiValue("Cabuffcyt", IxbCaM, ref bCaM);
            ListView.LVModiValue("Cabuffcyt", IxkonCaM, ref konCaM);
            ListView.LVModiValue("Cabuffcyt", IxkoffCaM, ref koffCaM);
            ListView.LVModiValue("Cabuffcyt", IxCaMtot, ref CaMtot);

            ListView.LVModiValue("Cabuffcyt", IxbMyocinCa, ref bMyocinCa);
            ListView.LVModiValue("Cabuffcyt", IxkonMyocinCa, ref konMyocinCa);
            ListView.LVModiValue("Cabuffcyt", IxkoffMyocinCa, ref koffMyocinCa);
            ListView.LVModiValue("Cabuffcyt", IxbMyocinMg, ref bMyocinMg);
            ListView.LVModiValue("Cabuffcyt", IxkonMyocinMg, ref konMyocinMg);
            ListView.LVModiValue("Cabuffcyt", IxkoffMyocinMg, ref koffMyocinMg);
            ListView.LVModiValue("Cabuffcyt", IxMyocintot, ref Myocintot);

            ListView.LVModiValue("Cabuffcyt", IxbSRB, ref bSRB);
            ListView.LVModiValue("Cabuffcyt", IxkonSRB, ref konSRB);
            ListView.LVModiValue("Cabuffcyt", IxkoffSRB, ref koffSRB);
            ListView.LVModiValue("Cabuffcyt", IxSRBtot, ref SRBtot);

            ListView.LVModiValue("Cabuffcyt", IxJCabuff_cyt_tot, ref JCabuff_cyt_tot);
        }
    }
}
