﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace HL_1
{
    public class cCadiff_cytsl : cElement
    {
        private Pd.TIdx IxJCadif_cytsl;
        private Pd.TIdx Ixpermeability_cytsl;
        private Pd.TIdx IxCacyt;
        private Pd.TIdx IxCasl;

        public double JCadif_cytsl;
        public double permeability_cytsl = 5000; // permeability for Ca diffusion cytoplasm to SL
        public double Cacyt;
        public double Casl;

        public cCadiff_cytsl()  //コンストラクター 
        {
        }

        override public void Initialize(ref double[] myTVc, ref cCell myCell, ref ListForm Lf)
        {
            int i = 0;

            SetIx(ref IxJCadif_cytsl, ref i, Pd.IntVar, "JCadif_cytsl");
            SetIx(ref Ixpermeability_cytsl, ref i, Pd.IntPar, "permeability_cytsl");
            SetIx(ref IxCacyt, ref i, Pd.IntVar, "Cacyt");
            SetIx(ref IxCasl, ref i, Pd.IntVar, "Casl");

            NumOfIx = i;

            Lf.DGViews_Initialize(Lf.tpCadiff_cytsl_ListView, NumOfIx);
        }

        override public void dydt(double dt, ref double[] tvDYdt, ref double[] tvY, cCell myCell)
        {
            Casl = tvY[Pd.IdxCasl];
            Cacyt = tvY[Pd.IdxCai];

            JCadif_cytsl = permeability_cytsl * (Casl-Cacyt);
        }

        override public void TransforToTV(ref double[] myTVc, cCell myCell)
        {
            myTVc[Pd.InxJCadiff_cytsl] = JCadif_cytsl;
        }

        override public void DispValues(ref ListForm Lf)
        {
            ucListView ListView = Lf.tpCadiff_cytsl_ListView;
            ListView.LVDispValue("Cadiff_cytsl", IxJCadif_cytsl, ref JCadif_cytsl);
            ListView.LVDispValue("Cadiff_cytsl", Ixpermeability_cytsl, ref permeability_cytsl);
            ListView.LVDispValue("Cadiff_cytsl", IxCacyt, ref Cacyt);
            ListView.LVDispValue("Cadiff_cytsl", IxCasl, ref Casl);
        }
        override public void ModiValues(ref ListForm Lf)
        {
            ucListView ListView = Lf.tpCadiff_cytsl_ListView;
            ListView.LVModiValue("Cadiff_cytsl", IxJCadif_cytsl, ref JCadif_cytsl);
            ListView.LVModiValue("Cadiff_cytsl", Ixpermeability_cytsl, ref permeability_cytsl);
            ListView.LVModiValue("Cadiff_cytsl", IxCacyt, ref Cacyt);
            ListView.LVModiValue("Cadiff_cytsl", IxCasl, ref Casl);
        }
    }
}
