﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace HL_1
{
    public class cCadiff_jssl : cElement
    {
        private Pd.TIdx IxJCadif_jssl;
        private Pd.TIdx Ixpermeability_jssl;
        private Pd.TIdx IxCajs;
        private Pd.TIdx IxCasl;

        public double JCadif_jssl;
        public double permeability_jssl = 824.13; // permeability for Ca diffusion JS to SL
        public double Cajs;
        public double Casl;

        public cCadiff_jssl()  //コンストラクター 
        {
        }

        override public void Initialize(ref double[] myTVc, ref cCell myCell, ref ListForm Lf)
        {
            int i = 0;

            SetIx(ref IxJCadif_jssl, ref i, Pd.IntVar, "JCadif_jssl");
            SetIx(ref Ixpermeability_jssl, ref i, Pd.IntPar, "permeability_jssl");
            SetIx(ref IxCajs, ref i, Pd.IntVar, "Cajs");
            SetIx(ref IxCasl, ref i, Pd.IntVar, "Casl");

            NumOfIx = i;

            Lf.DGViews_Initialize(Lf.tpCadiff_jssl_ListView, NumOfIx);
        }

        override public void dydt(double dt, ref double[] tvDYdt, ref double[] tvY, cCell myCell)
        {
            Casl = tvY[Pd.IdxCasl];
            Cajs = tvY[Pd.IdxCajs];

            JCadif_jssl = permeability_jssl * (Casl-Cajs);
        }

        override public void TransforToTV(ref double[] myTVc, cCell myCell)
        {
            myTVc[Pd.InxJCadiff_jssl] = JCadif_jssl;
        }

        override public void DispValues(ref ListForm Lf)
        {
            ucListView ListView = Lf.tpCadiff_jssl_ListView;
            ListView.LVDispValue("Cadiff_jssl", IxJCadif_jssl, ref JCadif_jssl);
            ListView.LVDispValue("Cadiff_jssl", Ixpermeability_jssl, ref permeability_jssl);
            ListView.LVDispValue("Cadiff_jssl", IxCajs, ref Cajs);
            ListView.LVDispValue("Cadiff_jssl", IxCasl, ref Casl);
        }
        override public void ModiValues(ref ListForm Lf)
        {
            ucListView ListView = Lf.tpCadiff_jssl_ListView;
            ListView.LVModiValue("Cadiff_jssl", IxJCadif_jssl, ref JCadif_jssl);
            ListView.LVModiValue("Cadiff_jssl", Ixpermeability_jssl, ref permeability_jssl);
            ListView.LVModiValue("Cadiff_jssl", IxCajs, ref Cajs);
            ListView.LVModiValue("Cadiff_jssl", IxCasl, ref Casl);
        }
    }
}
