﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace HL_1
{
    public class cCalsequestrin : cElement
    {
        private Pd.TIdx IxbCSQN;
        private Pd.TIdx IxkonCSQN;
        private Pd.TIdx IxkoffCSQN;
        private Pd.TIdx IxCSQNtot;

        private Pd.TIdx IxJCSQN;

        public double bCSQN;  // bound CSQN
        public double konCSQN = 100.0; // /mM*msec
        public double koffCSQN = 65.0; // /msec
        public double CSQNtot = 0.13; // mM

        public double JCSQN;

        public cCalsequestrin()  //コンストラクター 
        {
        }

        override public void Initialize(ref double[] myTVc, ref cCell myCell, ref ListForm Lf)
        {
            int i = 0;

            SetIx(ref IxbCSQN, ref i, Pd.IntVar, "bCSQN");
            SetIx(ref IxkonCSQN, ref i, Pd.IntPar, "konCSQN");
            SetIx(ref IxkoffCSQN, ref i, Pd.IntPar, "koffCSQN");
            SetIx(ref IxCSQNtot, ref i, Pd.IntPar, "CSQNtot");

            SetIx(ref IxJCSQN, ref i, Pd.IntVar, "JCSQN");

            NumOfIx = i;

            Lf.DGViews_Initialize(Lf.tpCalsequestrin_ListView, NumOfIx);

            bCSQN = myTVc[Pd.IdxbCSQN];
            JCSQN = myTVc[Pd.InxJCSQN];
        }

        override public void dydt(double dt, ref double[] tvDYdt, ref double[] tvY, cCell myCell)
        {
            double Casr = tvY[Pd.IdxCasr];
            double Vi = myCell.Cyt.Vcyt;
            double Vsr = myCell.SR.Vsr;
            double volumeratio = Vi / Vsr;

            double totB = CSQNtot * volumeratio;

            bCSQN = tvY[Pd.IdxbCSQN];

            tvDYdt[Pd.IdxbCSQN] = konCSQN * Casr * (totB - bCSQN) - koffCSQN * bCSQN;
            JCSQN = tvDYdt[Pd.IdxbCSQN];
        }

        override public void TransforToTV(ref double[] myTVc, cCell myCell)
        {
            myTVc[Pd.InxJCSQN] = JCSQN;
        }

        override public void DispValues(ref ListForm Lf)
        {
            ucListView ListView = Lf.tpCalsequestrin_ListView;
            ListView.LVDispValue("CSQN", IxbCSQN, ref bCSQN);
            ListView.LVDispValue("CSQN", IxkonCSQN, ref konCSQN);
            ListView.LVDispValue("CSQN", IxkoffCSQN, ref koffCSQN);
            ListView.LVDispValue("CSQN", IxCSQNtot, ref CSQNtot);

            ListView.LVDispValue("CSQN", IxJCSQN, ref JCSQN);
        }

        override public void ModiValues(ref ListForm Lf)
        {
            ucListView ListView = Lf.tpCalsequestrin_ListView;
            ListView.LVModiValue("CSQN", IxbCSQN, ref bCSQN);
            ListView.LVModiValue("CSQN", IxkonCSQN, ref konCSQN);
            ListView.LVModiValue("CSQN", IxkoffCSQN, ref koffCSQN);
            ListView.LVModiValue("CSQN", IxCSQNtot, ref CSQNtot);

            ListView.LVModiValue("CSQN", IxJCSQN, ref JCSQN);
        }
    }
}
