﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace HL_1
{
    public class cIpCasl : cElement
    {
         private Pd.TIdx IxApCa;
        private Pd.TIdx IxKmpCa;
        public double ApCa = 0.0673; // pA/pF
        public double KmpCa = 5.0e-4; // mM

        public cIpCasl()  //コンストラクター
        {
        }

        override public void Initialize(ref double[] myTVc, ref cCell myCell, ref ListForm Lf)
        {
            int i = 0;

            SetIx(ref IxSF, ref i, Pd.IntPar, "SF");
            SetIx(ref IxItc, ref i, Pd.IntVar, "Itc");
            SetIx(ref IxApCa, ref i, Pd.IntPar, "ApCa");
            SetIx(ref IxKmpCa, ref i, Pd.IntPar, "KmpCa");

            NumOfIx = i;

            Lf.DGViews_Initialize(Lf.tpIpCasl_ListView, NumOfIx);

            Itc = myTVc[Pd.InxIpCasl_Itc];
        }

        override public void dydt(double dt, ref double[] tvDYdt, ref double[] tvY, cCell myCell)
        {
            double Cai = tvY[Pd.IdxCasl]; 
            Itc = SF * myCell.SL.fraction_sl * ApCa * Math.Pow(Cai, 1.6) / (Math.Pow(KmpCa, 1.6) + Math.Pow(Cai, 1.6));
        }

        override public void TransforToTV(ref double[] myTVc, cCell myCell)
        {
            double Cai = myTVc[Pd.IdxCasl];
            Itc = SF * myCell.SL.fraction_sl * ApCa * Math.Pow(Cai, 1.6) / (Math.Pow(KmpCa, 1.6) + Math.Pow(Cai, 1.6));

            myTVc[Pd.InxIpCasl_Itc] = Itc;
        }

        override public void DispValues(ref ListForm Lf)
        {
            ucListView ListView = Lf.tpIpCasl_ListView;
            ListView.LVDispValue("IpCasl", IxSF, ref SF);
            ListView.LVDispValue("IpCasl", IxItc, ref Itc);
            ListView.LVDispValue("IpCasl", IxApCa, ref ApCa);
            ListView.LVDispValue("IpCasl", IxKmpCa, ref KmpCa);
        }

        override public void ModiValues(ref ListForm Lf)
        {
            ucListView ListView = Lf.tpIpCasl_ListView;
            ListView.LVModiValue("IpCasl", IxSF, ref SF);
            ListView.LVModiValue("IpCasl", IxItc, ref Itc);
            ListView.LVModiValue("IpCasl", IxApCa, ref ApCa);
            ListView.LVModiValue("IpCasl", IxKmpCa, ref KmpCa);
        }
    }
}
