﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace HL_1
{
    public class cItojs : cElement
    {
        private Pd.TIdx Ixxto;
        private Pd.TIdx Ixxto_inf;
        private Pd.TIdx Ixxto_tau;
        private Pd.TIdx Ixyto;
        private Pd.TIdx Ixyto_inf;
        private Pd.TIdx Ixyto_tau;
        private Pd.TIdx Ixgto;

        public double xto;
        public double xto_inf;
        public double xto_tau;
        public double yto;
        public double yto_inf;
        public double yto_tau;

        public double gto = 0.12375; // nS/pF

        public cItojs()  //コンストラクター
        {
        }

        override public void Initialize(ref double[] myTVc, ref cCell myCell, ref ListForm Lf)
        {
            int i = 0;

            SetIx(ref IxSF, ref i, Pd.IntPar, "SF");
            SetIx(ref IxItc, ref i, Pd.IntVar, "Itc");
            SetIx(ref Ixgto, ref i, Pd.IntPar, "gto");

            SetIx(ref Ixxto, ref i, Pd.IntVar, "xto");
            SetIx(ref Ixxto_inf, ref i, Pd.IntVar, "xto_inf");
            SetIx(ref Ixxto_tau, ref i, Pd.IntVar, "xto_tau");
            SetIx(ref Ixyto, ref i, Pd.IntVar, "yto");
            SetIx(ref Ixyto_inf, ref i, Pd.IntVar, "yto_inf");
            SetIx(ref Ixyto_tau, ref i, Pd.IntVar, "yto_tau");

            NumOfIx = i;

            Lf.DGViews_Initialize(Lf.tpItojs_ListView, NumOfIx);

            xto = myTVc[Pd.IdxIto_xto_js];
            yto = myTVc[Pd.IdxIto_yto_js];
            Itc = myTVc[Pd.InxItojs_Itc];
        }

        override public void dydt(double dt, ref double[] tvDYdt, ref double[] tvY, cCell myCell)
        {
            double Vm = tvY[Pd.IdxVm];

            xto_inf = 1.0 / (1.0 + Math.Exp((1 - Vm) / 11));
            xto_tau = 1.5 + 3.5 * Math.Exp(-(Vm / 30) * (Vm / 30));

            xto = tvY[Pd.IdxIto_xto_js];
            tvDYdt[Pd.IdxIto_xto_js] = (xto_inf - xto) / xto_tau;

            yto_inf = 1.0 / (1.0 + Math.Exp((Vm + 40.5) / 11.5));
            yto_tau = 21.21 + 38.4525 * Math.Exp(-((Vm + 52.45) / 15.8827) * ((Vm + 52.45) / 15.8827));

            yto = tvY[Pd.IdxIto_yto_js];
            tvDYdt[Pd.IdxIto_yto_js] = (yto_inf - yto) / yto_tau;

            Itc = SF * myCell.JS.fraction_js * gto * xto * yto * (Vm - myCell.Rp.K);
        }

        override public void TransforToTV(ref double[] myTVc, cCell myCell)
        {
            double Vm = myTVc[Pd.IdxVm];

            xto = myTVc[Pd.IdxIto_xto_js];
            yto = myTVc[Pd.IdxIto_yto_js];

            Itc = SF * myCell.JS.fraction_js * gto * xto * yto * (Vm - myCell.Rp.K);

            myTVc[Pd.InxItojs_Itc] = Itc;
        }

        override public void DispValues(ref ListForm Lf)
        {
            ucListView ListView = Lf.tpItojs_ListView;
            ListView.LVDispValue("Itojs", IxSF, ref SF);
            ListView.LVDispValue("Itojs", IxItc, ref Itc);
            ListView.LVDispValue("Itojs", Ixgto, ref gto);

            ListView.LVDispValue("Itojs", Ixxto, ref xto);
            ListView.LVDispValue("Itojs", Ixxto_inf, ref xto_inf);
            ListView.LVDispValue("Itojs", Ixxto_tau, ref xto_tau);
            ListView.LVDispValue("Itojs", Ixyto, ref yto);
            ListView.LVDispValue("Itojs", Ixyto_inf, ref yto_inf);
            ListView.LVDispValue("Itojs", Ixyto_tau, ref yto_tau);
        }

        override public void ModiValues(ref ListForm Lf)
        {
            ucListView ListView = Lf.tpItojs_ListView;
            ListView.LVModiValue("Itojs", IxSF, ref SF);
            ListView.LVModiValue("Itojs", IxItc, ref Itc);
            ListView.LVModiValue("Itojs", Ixgto, ref gto);

            ListView.LVModiValue("Itojs", Ixxto, ref xto);
            ListView.LVModiValue("Itojs", Ixxto_inf, ref xto_inf);
            ListView.LVModiValue("Itojs", Ixxto_tau, ref xto_tau);
            ListView.LVModiValue("Itojs", Ixyto, ref yto);
            ListView.LVModiValue("Itojs", Ixyto_inf, ref yto_inf);
            ListView.LVModiValue("Itojs", Ixyto_tau, ref yto_tau);
        }
    }
}
