﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace HL_1
{
    public class cLeak : cElement
    {
        private Pd.TIdx IxVmax_Leak;
        private Pd.TIdx IxJLeak;

        public double Vmax_Leak = 2.0e-5; // /ms
        public double JLeak;

        public cLeak()  //コンストラクター
        {
        }

        override public void Initialize(ref double[] myTVc, ref cCell myCell, ref ListForm Lf)
        {
            int i = 0;

            SetIx(ref IxSF, ref i, Pd.IntPar, "SF");
            SetIx(ref IxItc, ref i, Pd.IntVar, "Itc");
            SetIx(ref IxVmax_Leak, ref i, Pd.IntPar, "Vmax_Leak");

            SetIx(ref IxJLeak, ref i, Pd.IntVar, "JLeak");

            NumOfIx = i;

            Lf.DGViews_Initialize(Lf.tpLeak_ListView, NumOfIx);

            Itc = myTVc[Pd.InxLeak_Itc];
            JLeak = myTVc[Pd.InxJLeak];
        }

        override public void dydt(double dt, ref double[] tvDYdt, ref double[] tvY, cCell myCell)
        {
            double Cajs = tvY[Pd.IdxCajs];
            double Casr = tvY[Pd.IdxCasr];
            double Vcyt = myCell.Cyt.Vcyt;

            JLeak = SF * Vmax_Leak * (Casr - Cajs);
            Itc = (Vcyt * Pd.F * 2 / myCell.Cm) * JLeak;
        }

        override public void TransforToTV(ref double[] myTVc, cCell myCell)
        {
            myTVc[Pd.InxLeak_Itc] = Itc;
            myTVc[Pd.InxJLeak] = JLeak;
        }

        override public void DispValues(ref ListForm Lf)
        {
            ucListView ListView = Lf.tpLeak_ListView;
            ListView.LVDispValue("Leak", IxSF, ref SF);
            ListView.LVDispValue("Leak", IxItc, ref Itc);
            ListView.LVDispValue("Leak", IxVmax_Leak, ref Vmax_Leak);

            ListView.LVDispValue("Leak", IxJLeak, ref JLeak);
        }

        override public void ModiValues(ref ListForm Lf)
        {
            ucListView ListView = Lf.tpLeak_ListView;
            ListView.LVModiValue("Leak", IxSF, ref SF);
            ListView.LVModiValue("Leak", IxItc, ref Itc);
            ListView.LVModiValue("Leak", IxVmax_Leak, ref Vmax_Leak);

            ListView.LVModiValue("Leak", IxJLeak, ref JLeak);
        }
    }
}
