﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace HL_1
{
    public class cSL : cElement
    {
        public cCabuffsl Cabuffsl = new cCabuffsl(); 
        
        private Pd.TIdx IxVsl;
        private Pd.TIdx IxVsl_part;
        private Pd.TIdx IxCasl;
        private Pd.TIdx Ixfraction_sl;
        private Pd.TIdx Ixfraction_slCa;
        private Pd.TIdx IxCasl_Min;
        private Pd.TIdx IxCasl_Max;

        public double Vsl ;
        public double Vsl_part = 0.013; // part of cell volume occupied with subsarcolemmal space
        public double Casl;  // Ca concentration in subsarcolemmal space (mM)

        public double fraction_sl = 0.89;
        public double fraction_slCa = 0.1;

        public double Casl_Min;
        public double Casl_Max;

        public cSL()  //コンストラクター 
        {
        }

        override public void Initialize(ref double[] myTVc, ref cCell myCell, ref ListForm Lf)
        {
            Casl = myTVc[Pd.IdxCasl];
            Vsl = Vsl_part * myCell.Vcell;

            Cabuffsl.Initialize(ref myTVc, ref myCell, ref Lf);

            int i = 0;

            SetIx(ref IxVsl, ref i, Pd.IntVar, "Vsl");
            SetIx(ref IxVsl_part, ref i, Pd.IntVar, "Vsl_part");
            SetIx(ref IxCasl, ref i, Pd.IntVar, "Casl");
            SetIx(ref Ixfraction_sl, ref i, Pd.IntPar, "fraction_sl");
            SetIx(ref Ixfraction_slCa, ref i, Pd.IntPar, "fraction_slCa");
            SetIx(ref IxCasl_Min, ref i, Pd.IntVar, "Casl_Min");
            SetIx(ref IxCasl_Max, ref i, Pd.IntVar, "Casl_Max");

            NumOfIx = i;

            Lf.DGViews_Initialize(Lf.tpSL_ListView, NumOfIx);
        }

        override public void dydt(double dt, ref double[] tvDYdt, ref double[] tvY, cCell myCell)
        {
            Cabuffsl.dydt(dt, ref tvDYdt, ref tvY, myCell);
            tvDYdt[Pd.IdxCasl] = -(myCell.ICaLsl.ICaL_Ca + myCell.ICaTsl.Itc + myCell.IpCasl.Itc + myCell.ICabsl.Itc - 2 * myCell.INaCasl.Itc) * (myCell.Cm / (Vsl * 2 * Pd.F)) - myCell.Cadiff_jssl.JCadif_jssl / Vsl - myCell.Cadiff_cytsl.JCadif_cytsl / Vsl - (tvDYdt[Pd.IdxbCabuffsl_low] + tvDYdt[Pd.IdxbCabuffsl_high]);
        }

        override public void TransforToTV(ref double[] myTVc, cCell myCell)
        {
            Casl = myTVc[Pd.IdxCasl]; 
            Cabuffsl.TransforToTV(ref myTVc, myCell);
        }

        override public void DispValues(ref ListForm Lf)
        {
            ucListView ListView = Lf.tpSL_ListView;
            ListView.LVDispValue("SL", IxVsl, ref Vsl);
            ListView.LVDispValue("SL", IxVsl_part, ref Vsl_part);
            ListView.LVDispValue("SL", IxCasl, ref Casl);

            ListView.LVDispValue("SL", Ixfraction_sl, ref fraction_sl);
            ListView.LVDispValue("SL", Ixfraction_slCa, ref fraction_slCa);

            ListView.LVDispValue("SL", IxCasl_Min, ref Casl_Min);
            ListView.LVDispValue("SL", IxCasl_Max, ref Casl_Max);


            Cabuffsl.DispValues(ref Lf);
        }
        override public void ModiValues(ref ListForm Lf)
        {
            ucListView ListView = Lf.tpSL_ListView;
            ListView.LVModiValue("SL", IxVsl, ref Vsl);
            ListView.LVModiValue("SL", IxVsl_part, ref Vsl_part);
            ListView.LVModiValue("SL", IxCasl, ref Casl);

            ListView.LVModiValue("SL", Ixfraction_sl, ref fraction_sl);
            ListView.LVModiValue("SL", Ixfraction_slCa, ref fraction_slCa);

            ListView.LVModiValue("SL", IxCasl_Min, ref Casl_Min);
            ListView.LVModiValue("SL", IxCasl_Max, ref Casl_Max);

            Cabuffsl.ModiValues(ref Lf);
        }
    }
}
